CLEAR
SET DEFAULT TO (LEFT(SYS(16), RAT("\", SYS(16))))

#INCLUDE "include.h"

#IF USE_SHELLEXECUTE
	DECLARE INTEGER ShellExecute IN shell32.dll ;
		INTEGER hwnd, ;
		STRING @lsOperation, ;
		STRING @lsFile, ;
		STRING @lsParameters, ;
		STRING @lsDirectory, ;
		INTEGER liShowCmd
	DECLARE INTEGER GetDesktopWindow IN user32.dll
#ENDIF

*/////////////////////////////////////////////////
*// Check external files
IF !FILE(WINRAR_UTILITY)
	ERROR (ERR_FILE_NOTFOUND + WINRAR_UTILITY)
ENDIF
LOCAL lcTempDir as String
lcTempDir = LOWER(FULLPATH(PATH_TMP))
IF !DIRECTORY(lcTempDir)
	ERROR (ERR_DIR_NOTFOUND + lcTempDir)
ENDIF
LOCAL lcUnpackDir as String
lcUnpackDir = JUSTSTEM(TEMPLATE_DOCX) 	
IF !DIRECTORY(lcTempDir + lcUnpackDir)
	ERROR (ERR_DIR_NOTFOUND + lcTempDir + lcUnpackDir + "." ;
		+ CRLF + ERR_USER_USE_PROG1 + "step2_filldocx.prg" + ERR_USER_USE_PROG2)
ENDIF

*////////////////////////////////////////////////////////////
*// Pack result as zip-file
#IF USE_SHELLEXECUTE
	LOCAL lcFileTemplateDocxTmp as String
	lcFileTemplateDocxTmp = lcTempDir + TEMPLATE_DOCX
	IF FILE(lcFileTemplateDocxTmp)
		ERASE (lcFileTemplateDocxTmp) && Important! delete source before pack
	ENDIF
	LOCAL lnRetCode as Integer, lcWinRarPrms as String 
	lnRetCode = 0
	lcWinRarPrms = PRM_PACK_WINRAR ;
		+ CHR(32) + '"' + lcUnpackDir + '.zip" "' + lcUnpackDir + '\*.*"'
	lnRetCode = ShellExecute(GetDesktopWindow(), "open" ;
		,WINRAR_UTILITY, lcWinRarPrms, lcTempDir, SW_HIDE)
	IF lnRetCode <= 32
		ERROR "ShellExecute: errorcode = " + LTRIM(STR(lnRetCode))
	ENDIF
#ELSE	
	LOCAL loWSH as Wscript.Shell;
		,OldPath As String 
	loWSH = CREATEOBJECT("Wscript.Shell")
	lcOldPath = FULLPATH(CURDIR())
	SET DEFAULT TO (lcTempDir)
	loWSH.Run("fromContentsToDocxUseWinRAR.cmd", 0, .T.)
	SET DEFAULT TO (lcOldPath)
	loWSH = NULL
#ENDIF
? LOWER(PROGRAM())+ ": " + MSG_USER_SUCCESS_STEP
IF PROGRAM(-1) = 1
	? MSG_USER_NEXT_STEP + "step4_CleanupAndShowResult.prg"
ENDIF	
