#DEFINE PATH_DATA	HOME(2) + "northwind\"
#DEFINE DBF_FILE	"employees"
*#DEFINE PATH_DATA	HOME(2)+ "tastrade\data\"
*#DEFINE DBF_FILE	"category"

#DEFINE SUBDIR_XML	"XML"

CLOSE TABLES ALL

LOCAL lcSys16 as String;
	,lcCurPath as String;
	,lcXmlPath as String;
	,lcAppPath as String; 
	,lcFileDbf as String
lcSys16 = SYS(16)
lcCurPath = LOWER(LEFT(lcSys16, RATC("\", lcSys16)))
lcAppPath = LOWER(LEFT(lcSys16, RATC("\", lcSys16, 2)))
lcXmlPath = ADDBS(LOWER(lcAppPath + SUBDIR_XML))
IF !DIRECTORY(lcXmlPath, 1)
	SET DEFAULT TO (lcAppPath)
	MKDIR (SUBDIR_XML)
	SET DEFAULT TO (lcCurPath)
	IF !DIRECTORY(lcXmlPath, 1)
		ERROR 1102, lcXmlPath
	ENDIF
ENDIF

LOCAL lcFileDbf as String
lcFileDbf = LOWER(FORCEEXT(PATH_DATA + DBF_FILE, "dbf"))
IF !FILE(lcFileDbf)
	ERROR 101, lcFileDbf
ENDIF

LOCAL lcCursor as String
IF DBF_FILE = "employees"
	lcCursor = "employee"
	SELECT TOP 5 lastname, firstname, birthdate, notes ;
		FROM (lcFileDbf) ORDER BY lastname, firstname ;
		INTO CURSOR (lcCursor)
ELSE	
	lcCursor = DBF_FILE
	IF !USED(lcCursor)
		USE (lcFileDbf) IN 0 SHARED
	ENDIF
ENDIF	 
IF !USED(lcCursor)
	ERROR 101, lcFileDbf 
ENDIF

LOCAL lcFileXml as String 
SET SAFETY OFF 
SET DEFAULT TO (lcXmlPath)
?CURSORTOXML(lcCursor, lcCursor, 1, 512+8, 0, lcCursor)
lcFileXml = LOWER(FULLPATH(FORCEEXT(lcCursor, 'xml')))
SET DEFAULT TO (lcCurPath)
SET SAFETY OFF 

IF FILE(lcFileXml)
	LOCAL lcFileXsd as String 
	lcFileXsd = FORCEEXT(lcFileXml, 'xsd')
	IF FILE(lcFileXsd)
		?"Files: " + JUSTFNAME(lcFileXml) + ", " + JUSTFNAME(lcFileXsd) ;
			+ " in '" + JUSTPATH(lcXmlPath) + "' was created."
	ENDIF	
ENDIF

CLOSE TABLES ALL
CLOSE DATABASES ALL