#DEFINE PATH_COMMON_TOOLS		"..\..\CommonTools\"
#INCLUDE "..\..\CommonTools\SolWestWindEx.h"
#INCLUDE "..\..\CommonTools\FrameworkWrap.h"

#DEFINE RUS_LANG	.T.
#DEFINE TMP_OUT		.T.
#DEFINE CRLF		CHR(13) + CHR(10)
#DEFINE SW_NORMAL	1

#DEFINE PATH_XML				"..\..\XML\"
#DEFINE PATH_DOCX				"..\..\DOCX\"
#DEFINE PATH_XSLT				"..\..\XSLT\"
#DEFINE XML_DATA_FILE			"employee.XML"
#DEFINE XSLT_FILE				"genXsltFromTemplate.xslt"
#DEFINE XSLT_FILE_FIRST_RESULT	"getXmlDocument.xslt"
#DEFINE XML_FILE_SECOND_RESULT	"document.xml"
#DEFINE URI_DOCUMENT_XML		"/word/document.xml"
#DEFINE USE_ENCODING			"utf-8"
#DEFINE XML_PI	'<?xml version="1.0" encoding="' + USE_ENCODING + '" standalone="yes"?>' + CRLF
#DEFINE MYDOC_FOLDER			"MyDocuments"

#IF RUS_LANG
	#DEFINE TEMPLATE_DOCX			" VFP-   MS Word 2007.docx"
	#DEFINE ERR_VFP_VERSION			",     VFP 8.0 ( )."
	#DEFINE ERR_LABEL_OUTPUT		"***  : "
	#DEFINE ERR_DIR_NOTFOUND		"  : "
	#DEFINE ERR_FILE_NOTFOUND		"  : "
	#DEFINE ERR_EMPTY_XML			" xml- : "
	#DEFINE ERR_EMPTY_XSLTRES		" xslt-  : "
	#DEFINE ERR_CODE				" : "
	#DEFINE ERR_MESSAGE				"  : "
	#DEFINE ERR_LINE				" : "
	#DEFINE DOC_PROP_DESCRIPTION	"          xml-."
	#DEFINE DOC_PROP_SUBJECT		" Open XML   MS Word 2007"
	#DEFINE MSG_SUCCESS_RESUT		"  !       MS Word 2007..."
#ELSE
	#DEFINE TEMPLATE_DOCX			"Example VFP-table in MS Word 2007.docx"
	#DEFINE ERR_VFP_VERSION			"Sorry, this code for VFP 8.0 (or later)."
	#DEFINE ERR_LABEL_OUTPUT		"*** Error appears: "
	#DEFINE ERR_DIR_NOTFOUND		"Not found directory: "
	#DEFINE ERR_FILE_NOTFOUND		"Not found file: "
	#DEFINE ERR_EMPTY_XML			"Empty xml-data for: "
	#DEFINE ERR_EMPTY_XSLTRES		"Empty result of xslt-transformation for: "
	#DEFINE ERR_CODE				"Error code: "
	#DEFINE ERR_MESSAGE				"Message: "
	#DEFINE ERR_LINE				"Line: "
	#DEFINE DOC_PROP_DESCRIPTION	"The document is created on the basis of template and is filled by data from a xml-file from code program."
	#DEFINE DOC_PROP_SUBJECT		"Use Open XML format in MS Word 2007"
	#DEFINE MSG_SUCCESS_RESUT		"Process is successfully completed! Waiting of opening of the received new document in MS Word 2007..."
#ENDIF
