CLEAR
SET DEFAULT TO (LEFT(SYS(16), RAT("\", SYS(16))))

#INCLUDE "include.h"

#IF USE_SHELLEXECUTE
	DECLARE INTEGER ShellExecute IN shell32.dll ;
		INTEGER hwnd, ;
		STRING @lsOperation, ;
		STRING @lsFile, ;
		STRING @lsParameters, ;
		STRING @lsDirectory, ;
		INTEGER liShowCmd
	DECLARE INTEGER GetDesktopWindow IN user32.dll
#ENDIF

*/////////////////////////////////////////////////
*// Check external files
IF !FILE(WINRAR_UTILITY)
	ERROR (ERR_FILE_NOTFOUND + WINRAR_UTILITY)
ENDIF
LOCAL lcFileTemplateDocx as String
lcFileTemplateDocx = LOWER(FULLPATH(PATH_DOCX)) + TEMPLATE_DOCX
IF !FILE(lcFileTemplateDocx)
	ERROR (ERR_FILE_NOTFOUND + lcFileTemplateDocx)
ENDIF
LOCAL lcTempDir as String
lcTempDir = LOWER(FULLPATH(PATH_TMP))
IF !DIRECTORY(lcTempDir)
	ERROR (ERR_DIR_NOTFOUND + lcTempDir)
ENDIF

*/////////////////////////////////////////////////
*// Get copy & unpack FileTemplateDocx
LOCAL lcFileTemplateTmp as String
lcFileTemplateTmp = lcTempDir + TEMPLATE_DOCX
IF FILE(lcFileTemplateTmp)
	ERASE (lcFileTemplateTmp)
ENDIF
COPY FILE (lcFileTemplateDocx) TO (lcFileTemplateTmp)
#IF USE_SHELLEXECUTE
	LOCAL lnRetCode as Integer;
		,lcWinRarPrms as String 
	lnRetCode = 0
	lcWinRarPrms = PRM_UNPACK_WINRAR + CHR(32) + '"'+ TEMPLATE_DOCX + '"'
	lnRetCode = ShellExecute(GetDesktopWindow(), "open";
		,WINRAR_UTILITY, lcWinRarPrms, lcTempDir, SW_HIDE)
	IF lnRetCode <= 32
		ERROR "ShellExecute: errorcode = " + LTRIM(STR(lnRetCode))
	ENDIF
#ELSE
	LOCAL loWSH as Wscript.Shell;
		,lcOldPath as String 
	loWSH = CREATEOBJECT("Wscript.Shell")
	lcOldPath = FULLPATH(CURDIR())
	SET DEFAULT TO (lcTempDir)
	?loWSH.Run("getContentsUseWinRAR.cmd", 0, .T.)
	SET DEFAULT TO (lcOldPath)
#ENDIF
? LOWER(PROGRAM())+ ": " + MSG_USER_SUCCESS_STEP
IF PROGRAM(-1) = 1
	? MSG_USER_NEXT_STEP + "step2_filldocx.prg"
ENDIF