CLEAR
SET DEFAULT TO (LEFT(SYS(16), RAT("\", SYS(16))))

#INCLUDE "include.h"

DECLARE INTEGER ShellExecute IN shell32.dll ;
	INTEGER hwnd, ;
	STRING @lsOperation, ;
	STRING @lsFile, ;
	STRING @lsParameters, ;
	STRING @lsDirectory, ;
	INTEGER liShowCmd
DECLARE INTEGER GetDesktopWindow IN user32.dll

*/////////////////////////////////////////////////
*// Check external files
LOCAL lcTempDir as String
lcTempDir = LOWER(FULLPATH(PATH_TMP))
IF !DIRECTORY(lcTempDir)
	ERROR (ERR_DIR_NOTFOUND + lcTempDir)
ENDIF

*/////////////////////////////////////////////////
*// Rename zip to docx
LOCAL lcUnpackDir as String
lcUnpackDir = JUSTSTEM(TEMPLATE_DOCX) 	
LOCAL lcFileZip as String;
	,lcFileDocx as String 
lcFileZip = FORCEEXT(lcTempDir + lcUnpackDir, 'zip')
lcFileDocx = FORCEEXT(lcFileZip, 'docx')
#IF USE_SHELLEXECUTE
	IF !FILE(lcFileZip)
		ERROR (ERR_FILE_NOTFOUND + lcFileZip + ".";
			+ CRLF + ERR_USER_USE_PROG1 + "step3_pack.prg" + ERR_USER_USE_PROG2)
	ENDIF	
	RENAME (lcFileZip) TO (lcFileDocx)
#ENDIF	
IF !FILE(lcFileDocx)
	ERROR (ERR_FILE_NOTFOUND + lcFileDocx + ".";
			+ CRLF + ERR_USER_USE_PROG1 + "step3_pack.prg" + ERR_USER_USE_PROG2)
ENDIF	

*///////////////////////////////////////////////////////////////////////
*// Get filename result target folder
LOCAL loWSH as WScript.Shell
loWSH =	CREATEOBJECT("WScript.Shell")
LOCAL lcOutputFolder as String;
	,lcSourceFile as String;
	,lcSourceFileDocx as String  
lcOutputFolder = loWSH.SpecialFolders(MYDOC_FOLDER)
loWSH = NULL
LOCAL lcOutputFileDocx as String 
lcOutputFileDocx = lcOutputFolder + "\_" + TEMPLATE_DOCX

*///////////////////////////////////////////////////////////////////////
*// Copy result to target folder
LOCAL loFSO as Scripting.FileSystemObject
loFSO = CREATEOBJECT("Scripting.FileSystemObject")
loFSO.CopyFile(lcFileDocx, lcOutputFileDocx, .T.)
loFSO.DeleteFolder(lcTempDir + lcUnpackDir, .T.)
loFSO = NULL
ERASE (lcFileDocx)

*///////////////////////////////////////////////////////////////////////
*// And show result in target folder
WAIT MSG_SUCCESS_RESUT WINDOW NOWAIT TIMEOUT 10
LOCAL lnRetCode as Integer
lnRetCode = 0 
lnRetCode = ShellExecute(GetDesktopWindow(), "open";
	,lcOutputFileDocx, "", "", SW_NORMAL)
IF lnRetCode <= 32
	ERROR "ShellExecute: errorcode = " + LTRIM(STR(lnRetCode))
ENDIF
? LOWER(PROGRAM())+ ": " + MSG_USER_SUCCESS_STEP
