#DEFINE XML_FILE	"documentData.xml"

CLOSE TABLES ALL
SET DEFAULT TO (LEFT(SYS(16), RAT("\", SYS(16))))
LOCAL loXA as XMLAdapter;
	,lcAlias as String 
loXA = CREATEOBJECT("XMLAdapter")
WITH loXA
	.LoadXML(FULLPATH(XML_FILE), .T.)
	IF .Tables.Count > 0
		FOR EACH loXmlTable as XMLTable IN .Tables
			WITH loXmlTable
				IF .Fields.Count > 0
					.ToCursor()
					IF !EMPTY(.Alias)
						lcAlias = .Alias
					ENDIF	
				ENDIF
			ENDWITH
		ENDFOR 
	ENDIF
ENDWITH	
IF !EMPTY(lcAlias) AND USED(lcAlias)
	SELECT (lcAlias)
	BROWSE NORMAL LAST NOWAIT
ENDIF