<?xml version="1.0" encoding="UTF-8" standalone="yes"?>
<!-- file: genXsltTableTemplate.xslt -->
<xsl:stylesheet version="1.0"
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
	xmlns:msxsl="urn:schemas-microsoft-com:xslt"
  xmlns:xsd="http://www.w3.org/2001/XMLSchema"
	xmlns:msdata="urn:schemas-microsoft-com:xml-msdata"
  xmlns:ve="http://schemas.openxmlformats.org/markup-compatibility/2006"
	xmlns:o="urn:schemas-microsoft-com:office:office"
	xmlns:r="http://schemas.openxmlformats.org/officeDocument/2006/relationships"
	xmlns:m="http://schemas.openxmlformats.org/officeDocument/2006/math"
	xmlns:v="urn:schemas-microsoft-com:vml"
	xmlns:wp="http://schemas.openxmlformats.org/drawingml/2006/wordprocessingDrawing"
	xmlns:w10="urn:schemas-microsoft-com:office:word"
	xmlns:w="http://schemas.openxmlformats.org/wordprocessingml/2006/main"
	xmlns:wne="http://schemas.microsoft.com/office/word/2006/wordml"
  exclude-result-prefixes="xsi msxsl xsd msdata">

  <xsl:output version="1.0" method="xml"
    encoding="utf-8" standalone="yes" />

  <xsl:param name="prmSchemaUri">
    <xsl:text>Schema_Employee</xsl:text>
  </xsl:param>
  <xsl:param name="prmSchemaElement">
    <xsl:text>VFPData</xsl:text>
  </xsl:param>
  <xsl:param name="prmTblStyle">
    <xsl:text>1-1</xsl:text>
  </xsl:param>
  <xsl:param name="prmTblType">
    <xsl:text>auto</xsl:text>
  </xsl:param>
  <xsl:param name="prmTblLook">
    <xsl:text>04A0</xsl:text>
  </xsl:param>
  <xsl:param name="prmTblColTwipsMeasure">
    <xsl:text>2393</xsl:text>
  </xsl:param>
  <xsl:param name="prmTblRsid">
    <xsl:text>00174F3F</xsl:text>
  </xsl:param>
  <xsl:param name="prmTblRStyle">
    <xsl:text>100000000000</xsl:text>
  </xsl:param>
  <xsl:param name="prmTblCStyle">
    <xsl:text>001000000000</xsl:text>
  </xsl:param>
  <xsl:param name="prmTblCType">
    <xsl:text>dxa</xsl:text>
  </xsl:param>
  <xsl:param name="prmTblColumns">
    <tblColumns>
      <tbl SchemaUri="Schema_Employee">
        <tblCol>
          <header>Фамилия</header>
          <width>2391</width>
          <lang>en-US</lang>
        </tblCol>
        <tblCol>
          <header>Имя</header>
          <width>2392</width>
					<lang>en-US</lang>
				</tblCol>
        <tblCol>
          <header>День рождения</header>
          <width>2393</width>
					<lang>ru-RU</lang>
				</tblCol>
        <tblCol>
          <header>Комментарий</header>
          <width>2394</width>
					<lang>en-US</lang>
				</tblCol>
      </tbl>
      <!-- ... -->
    </tblColumns>
  </xsl:param>

  <xsl:template match="/">
    <w:document xmlns:ve="http://schemas.openxmlformats.org/markup-compatibility/2006"
				xmlns:o="urn:schemas-microsoft-com:office:office"
				xmlns:r="http://schemas.openxmlformats.org/officeDocument/2006/relationships"
				xmlns:m="http://schemas.openxmlformats.org/officeDocument/2006/math"
				xmlns:v="urn:schemas-microsoft-com:vml"
				xmlns:wp="http://schemas.openxmlformats.org/drawingml/2006/wordprocessingDrawing"
				xmlns:w10="urn:schemas-microsoft-com:office:word"
				xmlns:w="http://schemas.openxmlformats.org/wordprocessingml/2006/main"
				xmlns:wne="http://schemas.microsoft.com/office/word/2006/wordml">
      <w:body>
        <xsl:call-template name="genTable">
          <xsl:with-param name="prmSchemaUri" select="$prmSchemaUri" />
          <xsl:with-param name="prmSchemaElement" select="$prmSchemaElement" />
          <xsl:with-param name="prmTblStyle" select="$prmTblStyle" />
          <xsl:with-param name="prmTblType" select="$prmTblType" />
          <xsl:with-param name="prmTblLook" select="$prmTblLook" />
          <xsl:with-param name="prmTblRStyle" select="$prmTblRStyle" />
          <xsl:with-param name="prmTblCStyle" select="$prmTblCStyle" />
          <xsl:with-param name="prmTblCType" select="$prmTblCType" />
        </xsl:call-template>
        <w:sectPr w:rsidR="00174F3F" w:rsidRPr="00883633" w:rsidSect="00EC3577">
          <w:pgSz w:w="11906" w:h="16838"/>
          <w:pgMar w:top="1134" w:right="850" w:bottom="1134" w:left="1701" w:header="708" w:footer="708" w:gutter="0"/>
          <w:cols w:space="708"/>
          <w:docGrid w:linePitch="360"/>
        </w:sectPr>
      </w:body>
    </w:document>
  </xsl:template>

  <xsl:template name="genTable">
    <xsl:param name="prmSchemaUri" />
    <xsl:param name="prmSchemaElement" />
    <xsl:param name="prmTblStyle" />
    <xsl:param name="prmTblType" />
    <xsl:param name="prmTblLook" />
    <xsl:param name="prmTblRStyle" />
    <xsl:param name="prmTblCStyle" />
    <xsl:param name="prmTblCType" />
    <w:customXml w:uri="{$prmSchemaUri}" w:element="{$prmSchemaElement}">
      <w:p w:rsidR="{$prmTblRsid}" w:rsidRDefault="{$prmTblRsid}"/>
      <w:tbl>
        <w:tblPr>
          <w:tblStyle w:val="{$prmTblStyle}"/>
          <w:tblW w:w="0" w:type="{$prmTblType}"/>
          <w:tblLook w:val="{$prmTblLook}"/>
        </w:tblPr>
        <w:tblGrid>
          <!-- Generate set of <w:gridCol ...> elements-->
					<xsl:for-each select="/.//xsd:schema/xsd:element[@name=$prmSchemaElement]//xsd:sequence/*">
            <xsl:variable name="curPos">
              <xsl:value-of select="position()"/>
            </xsl:variable>
            <xsl:variable name="curTblCol">
              <xsl:copy-of select="msxsl:node-set($prmTblColumns)/./tblColumns/tbl[@SchemaUri=$prmSchemaUri]/tblCol[number($curPos)]"/>
            </xsl:variable>
            <!-- <w:gridCol w:w="{$prmTblColTwipsMeasure}"/> -->
            <w:gridCol w:w="{msxsl:node-set($curTblCol)/./tblCol/width}"/>
          </xsl:for-each>
        </w:tblGrid>
        <w:tr w:rsidR="{$prmTblRsid}" w:rsidTr="{$prmTblRsid}">
          <w:trPr>
            <w:cnfStyle w:val="{$prmTblRStyle}"/>
          </w:trPr>
					<!-- Generate set of <w:tc>...<w:tc> elements as columns header -->
					<xsl:for-each select="/.//xsd:schema/xsd:element[@name=$prmSchemaElement]//xsd:sequence/*">
            <xsl:variable name="curPos">
              <xsl:value-of select="position()" />
            </xsl:variable>
            <xsl:variable name="curTblCol">
              <xsl:copy-of select="msxsl:node-set($prmTblColumns)/./tblColumns/tbl[@SchemaUri=$prmSchemaUri]/tblCol[number($curPos)]" />
            </xsl:variable>
            <xsl:variable name="curTblColWidth">
              <xsl:value-of select="msxsl:node-set($curTblCol)/./tblCol/width" />
            </xsl:variable>
            <w:tc>
              <w:tcPr>
                <!-- <w:tcW w:w="{$prmTblColTwipsMeasure}" w:type="{$prmTblCType}"/> -->
                <w:tcW w:w="{$curTblColWidth}" w:type="{$prmTblCType}"/>
              </w:tcPr>
              <w:p w:rsidR="{$prmTblRsid}" w:rsidRPr="{$prmTblRsid}" w:rsidRDefault="{$prmTblRsid}" w:rsidP="{$prmTblRsid}">
                <w:pPr>
                  <w:cnfStyle w:val="{$prmTblCStyle}"/>
                </w:pPr>
                <w:r>
                  <w:t>
                   <!-- <xsl:value-of select="@name"/> -->
                    <xsl:value-of select="msxsl:node-set($curTblCol)/./tblCol/header"/>
                  </w:t>
                </w:r>
              </w:p>
            </w:tc>
          </xsl:for-each>
        </w:tr>
				<!-- Generate group element <w:customXml...>...</w:customXml> -->
				<w:customXml w:element="{/.//xsd:schema/xsd:element[@name=$prmSchemaElement]//xsd:element/@name}">
          <w:tr w:rsidR="{$prmTblRsid}" w:rsidTr="{$prmTblRsid}">
            <w:trPr>
              <w:cnfStyle w:val="{$prmTblRStyle}"/>
            </w:trPr>
						<!-- Generate set of <w:customXml...><w:tc>...<w:tc></w:customXml> elements for columns data -->
						<xsl:for-each select="/.//xsd:schema/xsd:element[@name=$prmSchemaElement]//xsd:sequence/*">
              <xsl:variable name="curPos">
                <xsl:value-of select="position()"/>
              </xsl:variable>
              <xsl:variable name="curTblCol">
                <xsl:copy-of select="msxsl:node-set($prmTblColumns)/./tblColumns/tbl[@SchemaUri=$prmSchemaUri]/tblCol[number($curPos)]"/>
              </xsl:variable>
              <xsl:variable name="curTblColWidth">
                <xsl:value-of select="msxsl:node-set($curTblCol)/./tblCol/width" />
              </xsl:variable>
              <w:customXml w:element="{@name}">
                <w:tc>
                  <w:tcPr>
                    <!-- <w:tcW w:w="{$prmTblColTwipsMeasure}" w:type="{$prmTblCType}"/> -->
                    <w:tcW w:w="{$curTblColWidth}" w:type="{$prmTblCType}"/>
                  </w:tcPr>
                  <w:p w:rsidR="{$prmTblRsid}" w:rsidRDefault="{$prmTblRsid}" w:rsidP="{$prmTblRsid}">
                    <w:pPr>
                      <w:cnfStyle w:val="{$prmTblCStyle}"/>
                      <w:rPr>
                        <w:lang w:val="{msxsl:node-set($curTblCol)/./tblCol/lang}"/>
                      </w:rPr>
                    </w:pPr>
                  </w:p>
                </w:tc>
              </w:customXml>
            </xsl:for-each>
          </w:tr>
        </w:customXml>
      </w:tbl>
      <w:p w:rsidR="{$prmTblRsid}" w:rsidRDefault="{$prmTblRsid}"/>
    </w:customXml>
  </xsl:template>

</xsl:stylesheet>